Imports System.Runtime.Remoting
Imports System.Runtime.Remoting.Channels
Imports System.Runtime.Remoting.Channels.Http

Public Class SyncAsync
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnSync As System.Windows.Forms.Button
    Friend WithEvents btnAsync As System.Windows.Forms.Button
    Friend WithEvents txtResults As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnSync = New System.Windows.Forms.Button()
        Me.btnAsync = New System.Windows.Forms.Button()
        Me.txtResults = New System.Windows.Forms.TextBox()
        Me.SuspendLayout()
        '
        'btnSync
        '
        Me.btnSync.Location = New System.Drawing.Point(8, 8)
        Me.btnSync.Name = "btnSync"
        Me.btnSync.Size = New System.Drawing.Size(208, 24)
        Me.btnSync.TabIndex = 0
        Me.btnSync.Text = "Call LongProcess Synchronously"
        '
        'btnAsync
        '
        Me.btnAsync.Location = New System.Drawing.Point(224, 8)
        Me.btnAsync.Name = "btnAsync"
        Me.btnAsync.Size = New System.Drawing.Size(208, 24)
        Me.btnAsync.TabIndex = 1
        Me.btnAsync.Text = "Call LongProcess Asynchronously"
        '
        'txtResults
        '
        Me.txtResults.Location = New System.Drawing.Point(8, 40)
        Me.txtResults.Multiline = True
        Me.txtResults.Name = "txtResults"
        Me.txtResults.Size = New System.Drawing.Size(424, 160)
        Me.txtResults.TabIndex = 2
        Me.txtResults.Text = ""
        '
        'SyncAsync
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(440, 213)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.txtResults, Me.btnAsync, Me.btnSync})
        Me.Name = "SyncAsync"
        Me.Text = "SyncAsync"
        Me.ResumeLayout(False)

    End Sub

#End Region
    ' Remotable object
    Dim remObject As RemotableClass

    ' Create a delegate for the LongProcess method
    ' of the Remotable object
    Delegate Function LongProcessDelegate(ByVal param As String) As String

    ' Declare a LongProcessDelegate object, an AsyncCallback 
    ' delegate object and an IAsyncResult object
    Dim delLongProcess As LongProcessDelegate
    Dim ab As AsyncCallback
    Dim ar As IAsyncResult

    ' Declare an integer variable to hold 
    '  number of times the method is called
    Dim counter As Integer

    Private Sub SyncAsync_Load( _
     ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles MyBase.Load
        ' Register a Http client channel 
        Dim channel As HttpClientChannel = _
         New HttpClientChannel()
        ChannelServices.RegisterChannel(channel)

        ' Instantiate the remote class
        remObject = CType(Activator.GetObject( _
         GetType(RemotableClass), _
         "http://localhost/StepByStep3-20/RemotableClass.rem"), _
         RemotableClass)

        ' Create a AsyncCallback delegate object to hold the
        ' reference of the LongProcessCompleted method, which   
        ' is called when the asynchronous call is completed
        ab = New AsyncCallback(AddressOf LongProcessCompleted)

        ' Create a LongProcessDelegate delegate object to hold
        ' the reference of the LongProcess method 
        delLongProcess = New LongProcessDelegate( _
         AddressOf remObject.LongProcess)
    End Sub

    Private Sub btnSync_Click( _
     ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles btnSync.Click
        ' Increment the method call counter
        counter += 1
        Dim param As String = String.Format( _
         "Call: {0}, Type=Synchronous", counter)

        ' Append the start message to the text box
        txtResults.AppendText(String.Format( _
         "{0}, Started at: {1}" & vbCrLf, _
         param, DateTime.Now.ToLongTimeString()))

        ' Call the LongProcess method of the remotable object
        remObject.LongProcess(param)

        ' Append the completed message to the text box
        txtResults.AppendText( _
            String.Format("{0},  Completed at: {1}" & vbCrLf, _
            param, DateTime.Now.ToLongTimeString()))
    End Sub

    Private Sub btnAsync_Click( _
     ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles btnAsync.Click
        ' Increment the method call counter
        counter += 1
        Dim param As String = String.Format( _
         "Call: {0}, Type=Asynchronous", _
         counter)
        ' Append the start message to the text box
        txtResults.AppendText( _
         String.Format("{0}, Started at: {1}\n", _
         param, DateTime.Now.ToLongTimeString()))

        ' Call the BeginInvoke method to start 
        ' the asynchronous method call
        ar = delLongProcess.BeginInvoke(param, ab, Nothing)
    End Sub

    Sub LongProcessCompleted(ByVal ar As IAsyncResult)
        ' Call the EndInvoke method to retrieve the return
        ' value of the asynchronous method call
        Dim result As String = delLongProcess.EndInvoke(ar)

        ' Append the completed message to the text box
        txtResults.AppendText( _
        String.Format("{0}, Completed at: {1}\n", _
        result, DateTime.Now.ToLongTimeString()))
    End Sub

End Class
