Imports System.Data.SqlClient
Imports System.IO
Imports System.ServiceProcess

Public Class OrderService
    Inherits System.ServiceProcess.ServiceBase

#Region " Component Designer generated code "

    Public Sub New()
        MyBase.New()

        ' This call is required by the Component Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call

    End Sub

    'UserService overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' The main entry point for the process
    <MTAThread()> _
    Shared Sub Main()
        Dim ServicesToRun() As System.ServiceProcess.ServiceBase

        ' More than one NT Service may run within the same process. To add
        ' another service to this process, change the following line to
        ' create a second service object. For example,
        '
        '   ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1, New MySecondUserService}
        '
        ServicesToRun = New System.ServiceProcess.ServiceBase() {New OrderService()}

        System.ServiceProcess.ServiceBase.Run(ServicesToRun)
    End Sub

    'Required by the Component Designer
    Private components As System.ComponentModel.IContainer

    ' NOTE: The following procedure is required by the Component Designer
    ' It can be modified using the Component Designer.  
    ' Do not modify it using the code editor.
    Friend WithEvents fswOrders As System.IO.FileSystemWatcher
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.fswOrders = New System.IO.FileSystemWatcher()
        CType(Me.fswOrders, System.ComponentModel.ISupportInitialize).BeginInit()
        '
        'fswOrders
        '
        Me.fswOrders.Filter = "*.xml"
        Me.fswOrders.Path = "c:\Orders"
        '
        'OrderService
        '
        Me.CanPauseAndContinue = True
        Me.ServiceName = "OrderService"
        CType(Me.fswOrders, System.ComponentModel.ISupportInitialize).EndInit()

    End Sub

#End Region

    Protected Overrides Sub OnStart(ByVal args() As String)
        fswOrders.EnableRaisingEvents = True
    End Sub

    Protected Overrides Sub OnStop()
        fswOrders.EnableRaisingEvents = False
    End Sub

    Protected Overrides Sub OnPause()
        fswOrders.EnableRaisingEvents = False
    End Sub

    Protected Overrides Sub OnContinue()
        fswOrders.EnableRaisingEvents = True
    End Sub

    Private Sub fswOrders_Created( _
 ByVal sender As Object, _
 ByVal e As System.IO.FileSystemEventArgs) _
 Handles fswOrders.Created
        Dim dsOrders As DataSet = New DataSet("Orders")
        ' Read the contents of the XML file
        ' into the Orders DataSet
        dsOrders.ReadXml(e.FullPath)

        ' Set up the database connection string
        Dim strConn As String = "data source=(local);" & _
         "initial catalog=Northwind;" & _
         "integrated security=SSPI"
        Dim strOrderQuery As String = "SELECT * FROM Orders"
        ' Create a DataAdapter for the Orders
        ' table of the Northwind database
        Dim daOrders As SqlDataAdapter = _
         New SqlDataAdapter(strOrderQuery, strConn)
        ' Automatically generate the update
        ' command to reconcile the changes 
        ' made to the DataSet
        Dim cbOrders As SqlCommandBuilder = _
         New SqlCommandBuilder(daOrders)
        ' Update the DataSet
        daOrders.Update(dsOrders, "Orders")
        daOrders.Dispose()

        Dim fi As FileInfo = New FileInfo(e.FullPath)
        ' Create a subdirectory named "Updated"
        ' if it does not already exists
        fi.Directory.CreateSubdirectory("Updated")
        ' Copy the processed XML file to updated
        ' directory, overwriting if needed
        File.Copy(e.FullPath, fi.DirectoryName & _
         "\Updated\" + fi.Name, True)
        ' Delete the XML file from its 
        ' original location
        fi.Delete()
    End Sub

End Class
