Imports System.ServiceProcess
Public Class frmServiceController
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lbServiceList As System.Windows.Forms.ListBox
    Friend WithEvents lblStatus As System.Windows.Forms.Label
    Friend WithEvents btnStart As System.Windows.Forms.Button
    Friend WithEvents btnStop As System.Windows.Forms.Button
    Friend WithEvents btnPauseContinue As System.Windows.Forms.Button
    Friend WithEvents btnRefresh As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.lbServiceList = New System.Windows.Forms.ListBox()
        Me.lblStatus = New System.Windows.Forms.Label()
        Me.btnStart = New System.Windows.Forms.Button()
        Me.btnStop = New System.Windows.Forms.Button()
        Me.btnPauseContinue = New System.Windows.Forms.Button()
        Me.btnRefresh = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'lbServiceList
        '
        Me.lbServiceList.Location = New System.Drawing.Point(8, 8)
        Me.lbServiceList.Name = "lbServiceList"
        Me.lbServiceList.Size = New System.Drawing.Size(440, 212)
        Me.lbServiceList.TabIndex = 0
        '
        'lblStatus
        '
        Me.lblStatus.Location = New System.Drawing.Point(8, 232)
        Me.lblStatus.Name = "lblStatus"
        Me.lblStatus.Size = New System.Drawing.Size(440, 24)
        Me.lblStatus.TabIndex = 1
        Me.lblStatus.Text = "Label1"
        '
        'btnStart
        '
        Me.btnStart.Location = New System.Drawing.Point(8, 272)
        Me.btnStart.Name = "btnStart"
        Me.btnStart.Size = New System.Drawing.Size(96, 23)
        Me.btnStart.TabIndex = 2
        Me.btnStart.Text = "Start"
        '
        'btnStop
        '
        Me.btnStop.Location = New System.Drawing.Point(120, 272)
        Me.btnStop.Name = "btnStop"
        Me.btnStop.Size = New System.Drawing.Size(96, 23)
        Me.btnStop.TabIndex = 3
        Me.btnStop.Text = "Stop"
        '
        'btnPauseContinue
        '
        Me.btnPauseContinue.Location = New System.Drawing.Point(240, 272)
        Me.btnPauseContinue.Name = "btnPauseContinue"
        Me.btnPauseContinue.Size = New System.Drawing.Size(96, 23)
        Me.btnPauseContinue.TabIndex = 4
        Me.btnPauseContinue.Text = "Pause/Continue"
        '
        'btnRefresh
        '
        Me.btnRefresh.Location = New System.Drawing.Point(360, 272)
        Me.btnRefresh.Name = "btnRefresh"
        Me.btnRefresh.Size = New System.Drawing.Size(96, 23)
        Me.btnRefresh.TabIndex = 5
        Me.btnRefresh.Text = "Refresh"
        '
        'frmServiceController
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(456, 301)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnRefresh, Me.btnPauseContinue, Me.btnStop, Me.btnStart, Me.lblStatus, Me.lbServiceList})
        Me.Name = "frmServiceController"
        Me.Text = "Service Controller"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub frmServiceController_Load( _
     ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles MyBase.Load
        PopulateServiceList()
    End Sub

    ' Get the list of installed services
    Public Sub PopulateServiceList()
        ' Populate services in the list box
        lbServiceList.DataSource = _
         ServiceController.GetServices()
        ' Display friendly name
        lbServiceList.DisplayMember = "DisplayName"
    End Sub
    Private Sub lbServiceList_SelectedIndexChanged( _
     ByVal sender As System.Object, _
     ByVal e As System.EventArgs) _
     Handles lbServiceList.SelectedIndexChanged
        ' Retrieve the selected service
        Dim service As ServiceController = _
         CType(lbServiceList.SelectedItem, _
         ServiceController)
        ' And get status for it
        GetServiceStatus(service)
    End Sub

    ' Find the latest service status
    Public Sub GetServiceStatus(ByVal sc As ServiceController)
        ' Get the service status
        Dim status As ServiceControllerStatus = sc.Status
        ' Enable all buttons
        btnStart.Enabled = True
        btnStop.Enabled = True
        btnPauseContinue.Enabled = True
        ' Disable the pause button if the service does
        ' not support pause and continue command
        If Not sc.CanPauseAndContinue Then
            btnPauseContinue.Enabled = False
        End If
        ' Disable the stop button if the service does
        ' not support stop command
        If Not sc.CanStop Then
            btnStop.Enabled = False
        End If
        ' Enable and disable buttons based on 
        ' service status. Also display the text
        ' for the status 
        Select Case status
            Case ServiceControllerStatus.ContinuePending
                lblStatus.Text = "Continue Pending"
                btnPauseContinue.Enabled = False
            Case ServiceControllerStatus.Paused
                lblStatus.Text = "Paused"
                btnPauseContinue.Text = "Continue"
                btnStart.Enabled = False
            Case ServiceControllerStatus.PausePending
                lblStatus.Text = "Pause Pending"
                btnPauseContinue.Enabled = False
                btnStart.Enabled = False
            Case ServiceControllerStatus.Running
                lblStatus.Text = "Running"
                btnPauseContinue.Text = "Pause"
                btnStart.Enabled = False
            Case ServiceControllerStatus.StartPending
                lblStatus.Text = "Start Pending"
                btnStart.Enabled = False
            Case ServiceControllerStatus.Stopped
                lblStatus.Text = "Stopped"
                btnStop.Enabled = False
            Case ServiceControllerStatus.StopPending
                lblStatus.Text = "Stop Pending"
                btnStop.Enabled = False
            Case Else
                lblStatus.Text = "Unknown Status"
        End Select
    End Sub
    Private Sub btnStart_Click( _
     ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles btnStart.Click
        ' It might take time so change the
        ' cursor to a wait cursor
        Cursor.Current = Cursors.WaitCursor
        ' Retrieve the selected service
        Dim service As ServiceController = _
         CType(lbServiceList.SelectedItem, _
         ServiceController)
        ' Start the service and wait till 
        ' the status is Running
        service.Start()
        service.WaitForStatus( _
         ServiceControllerStatus.Running)
        ' Refresh the list
        Dim intIndex As Integer = lbServiceList.SelectedIndex
        PopulateServiceList()
        lbServiceList.SelectedIndex = intIndex
        ' Change the cursor back to normal
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub btnStop_Click( _
     ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles btnStop.Click
        ' It might take time so change the
        ' cursor to a wait cursor
        Cursor.Current = Cursors.WaitCursor
        ' Retrieve the selected service
        Dim service As ServiceController = _
         CType(lbServiceList.SelectedItem, _
         ServiceController)
        ' Start the service and wait till 
        ' the status is Running
        service.Stop()
        service.WaitForStatus( _
         ServiceControllerStatus.Stopped)
        ' Refresh the list
        Dim intIndex As Integer = lbServiceList.SelectedIndex
        PopulateServiceList()
        lbServiceList.SelectedIndex = intIndex
        ' Change the cursor back to normal
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub btnPauseContinue_Click( _
     ByVal sender As System.Object, _
     ByVal e As System.EventArgs) _
     Handles btnPauseContinue.Click
        ' It might take time so change the
        ' cursor to a wait cursor
        Cursor.Current = Cursors.WaitCursor
        ' Retrieve the selected service
        Dim service As ServiceController = _
         CType(lbServiceList.SelectedItem, _
         ServiceController)
        If btnPauseContinue.Text = "Pause" Then
            ' Pause the service and wait till 
            ' the status is Paused
            service.Pause()
            service.WaitForStatus( _
             ServiceControllerStatus.Paused)
        Else
            ' Resume the service and wait till 
            ' the status is Running
            service.Continue()
            service.WaitForStatus( _
             ServiceControllerStatus.Running)
        End If
        ' Refresh the list
        Dim intIndex As Integer = lbServiceList.SelectedIndex
        PopulateServiceList()
        lbServiceList.SelectedIndex = intIndex
        ' Change the cursor back to normal
        Cursor.Current = Cursors.Default
    End Sub

    Private Sub btnRefresh_Click( _
     ByVal sender As System.Object, _
     ByVal e As System.EventArgs) Handles btnRefresh.Click
        ' Refresh the list
        Dim intIndex As Integer = lbServiceList.SelectedIndex
        PopulateServiceList()
        lbServiceList.SelectedIndex = intIndex
    End Sub
End Class
