Imports System
Imports System.Diagnostics
Imports System.Text
Imports System.Web.Mail

Public Class EmailTraceListener
    Inherits TraceListener

    ' Mmessage log will be sent to this address
    Private mstrMailTo As String
    ' Storage for the message log
    Private mmessage As StringBuilder

    Public Sub New(ByVal MailTo As String)
        mstrMailTo = MailTo
    End Sub

    ' A custom listener must override Write method 
    Public Overloads Overrides Sub Write( _
     ByVal message As String)
        If mmessage Is Nothing Then
            mmessage = New StringBuilder()
        End If
        mmessage.Append(message)
    End Sub

    ' A custom listener must override WriteLine method
    Public Overloads Overrides Sub WriteLine( _
     ByVal message As String)
        If mmessage Is Nothing Then
            mmessage = New StringBuilder()
        End If
        mmessage.Append(message)
        mmessage.Append(vbCrLf)
    End Sub

    ' Use the close method to send the mail.
    Public Overrides Sub Close()
        Flush()
        Dim msg As MailMessage = New MailMessage()
        msg.To = mstrMailTo
        msg.From = "Administrator@test"
        msg.Subject = _
         "Factorial Program Debug/Trace output"
        If Not mmessage Is Nothing Then
            msg.Body = mmessage.ToString()
        Else
            msg.Body = ""
        End If
        ' Send the mail
        SmtpMail.Send(msg)
    End Sub

    Public Overrides Sub Flush()
        ' Nothing much to do here
        ' Just call the base class's implementation
        MyBase.Flush()
    End Sub

End Class
